import Prelude hiding (fmap, (>>=), join)

data MyMaybe a = MyJust a | MyNothing deriving (Show)

fmap :: (a -> b) -> MyMaybe a -> MyMaybe b
fmap _ MyNothing = MyNothing
fmap f (MyJust x) = MyJust $ f x

join :: MyMaybe (MyMaybe a) -> MyMaybe a
join MyNothing = MyNothing
join (MyJust x) = x

(>>=) :: MyMaybe a -> (a -> MyMaybe b) -> MyMaybe b
x >>= f = join . fmap f $ x
-- MyNothing >>= _ = MyNothing
-- MyJust x >>= f = f x

MyNothing >>= f = join . fmap f $ MyNothing
